//--------------------------------------------------------------------------------------
//Light
struct   sLightParam
{
	bool		enable;
	int			kind;			//0fBNVi@1|Cg	2X|bg
	float		attenuation;	//iǉIj
	float		range;			//LiǉIj
	float4		direction;		//CgƎ˕
	float4		directionInv;	//CgƎ˕(txNgj
	float4		pos;			//̈ʒuiǉIj
	float4		color;			//Cg̐F
};
struct   sLightsParam
{
	bool		enable;
	bool		n0;			//TCYp
	bool		n1;			//TCYp
	bool		n2;			//TCYp
	float4		ambient;
	sLightParam	light[4];
};
cbuffer  LightsCB{
	sLightsParam	 lights;
};
//--------------------------------------------------------------------------------------
//Fog
struct  sFogParam
{
	bool	enable;
	bool	mode;
	bool	n0;
	bool	n1;
	float	near;
	float	fore;
	float	p0;
	float	p1;
	float4	color;
};
cbuffer  FogCB
{
	sFogParam	fog;
};
//--------------------------------------------------------------------------------------
//Matrix
struct  sMatrixParam
{
	matrix		world;
	matrix		view;
	matrix		projection;

	matrix		w_v;
	matrix		w_v_p;
	matrix		v_p;
};
cbuffer  MatrixCB
{
	sMatrixParam		mat;
};
//--------------------------------------------------------------------------------------
//Material
struct  sMaterialParam
{
	float4		diffuse;
	float4		speculer;
	float4		ambient;
	float4		emissive;
	float4		objectColor;	//FύX
};
cbuffer  MaterialCB
{
	sMaterialParam	mate;
};
//--------------------------------------------------------------------------------------
//
struct  sEtcParam
{
	float4		eyePos;				//_W
};
cbuffer  EtcCB
{
	sEtcParam	etc;
};
//--------------------------------------------------------------------------------------
//eNX`
Texture2D	tex0, tex1, tex2, tex3, tex4, tex5, tex6, tex7;

//--------------------------------------------------------------------------------------
//Tv
//`ԁ@UV~[O
SamplerState  samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = MIRROR;	//Wrap;
    AddressV = MIRROR;	//Wrap;
};
//
//VF[_\0
//------------------------------------------------------------------
//ʔ˂̋txNg߂
float4  SpecularReflectInv(float4  toLight_,  float4  n_)//ʔ
{
	float  d =  dot(n_, toLight_);
	return  toLight_ + (n_ * (-d * 2));
}
//------------------------------------------------------------------
//CeBO
float4  Lighting(float4  pos_, float4  normal_,  sLightParam  lp_)
{
	float4  color  =  (float4)0;
	//fBNViisj
	if(lp_.kind  ==  0){
		//gU˂ɑ΂ʌvZ
		{	//ˊpɂʂ߂
			float  angleL  =  max(0, dot(normal_,  lp_.directionInv));
			//ˌ߂
			color  +=  lp_.color  *  mate.diffuse  *  angleL;
		}
		//ʔ˂ɑ΂ʌvZ(mFׂ̈̉ϔŁj
		{	//xNg߂
			float4  eyeVec  =  normalize(pos_  -  etc.eyePos);
			//ˌ̋txNg߂
			float4	refInv  =  SpecularReflectInv(lp_.directionInv,  normal_);
			//ˌƎɂʂ߂
			float  angleL  =  max(0,  dot(eyeVec,  refInv));
			//ˌ߂
			color  +=  lp_.color  *  mate.speculer  *  angleL;
		}
	//|Cg
	}else  if(lp_.kind  ==  1){
		//ˊpƋt̃xNgiɌxNgj߂
		float4  toLight  =  lp_.pos  -  pos_;
		//܂ł̋߂
		float  len  =  length(toLight);
		//LCeBOs
		if(lp_.range  >=  len){
			//ɂ̗ʂ߂îQŌキȂj
			float  distL  =  1 / max(1, len  *  len  *  lp_.attenuation);
			//ɌPʃxNg߂
			float4  toLightNormal  =  toLight  /  len;
			//gU˂ɑ΂ʌvZ
			{	//pxɂ锽ˌ̗ʂ߂
				//float  angleL  =  1.0f;		//ij
				float  angleL  =  max(0, dot(normal_,  toLightNormal));
				//gU˂ɑ΂ʌvZ
				color += lp_.color  *  mate.diffuse  *  angleL  *  distL;
			}
			//ʔ˂ɑ΂ʌvZ
			{	//xNg߂
				float4  eyeVec  =  normalize(pos_  -  etc.eyePos);
				//ˌ̋txNg߂
				float4	refInv  =  SpecularReflectInv(toLightNormal,  normal_);
				//ˌƎɂʂ߂
				float  angleL  =  max(0,  dot(eyeVec,  refInv));
				//ˌ߂
				color  +=  lp_.color  *  mate.speculer  *  angleL  *  distL;
			}
		}
	}else{
	}
	return  color;
}
//------------------------------------------------------------------
//o[ebNXVF[_o͍\́@@VF[_ł͂Ȃobt@ɂȂĂ̂͋Lq~X
struct sVS_PNT_Out
{	
    float4  pos			: SV_POSITION;
	float2  uv			: TEXCOORD0;
	float	viewZ		: POSITION0;
	float4  posW		: POSITION1;
	float4  norW		: NORMAL;
	//float4  color		: COLOR;
};
//------------------------------------------------------------------
//
//o[ebNXVF[_[
//
//_@@@UV̍\̒_ɑ΂鏈
//
sVS_PNT_Out  VS_PNT(	float3  pos_		: POSITION,
						float3  normal_		: NORMAL,
						float2  uv_			: TEXCOORD)
{
    sVS_PNT_Out output = (sVS_PNT_Out)0;

//@Iɂ͖ʂꂪǂ`ŋLqĂ

	//_Ɩ@[hϊ
	float4  posW  =  mul( float4(pos_.xyz,1), mat.world );
	float4  norW  =  mul( float4(normal_.xyz,0), mat.world );
	norW = normalize(norW);	//@͐K

	////CeBO(j
	//float4  color  =  float4(0,0,0,0);
	//if(lights.enable){
	//	for(int  i = 0;  i < 4;  i++){
	//		if(lights.light[i].enable){
	//			//gUˁEʔ
	//			color += Lighting(posW,  norW,  lights.light[i]);
	//		}
	//	}
	//	//˗ʂKp
	//	color += mate.ambient  *  lights.ambient;
	//	//x̓}eÃft[Y瓾
	//	color.a  =  mate.diffuse.a;
	//}
	//else{
	//	//Cg
	//	color += mate.diffuse;
	//}
	////ȔʂKp
	//color  +=  mate.emissive;
	////IuWFNgJ[iFύXjKp
	//color  *=  mate.objectColor;

	//_r[ϊ
	float4  posV  =  mul( posW, mat.view );
	//_vWFNVϊ
	float4  posP  =  mul( posV, mat.projection );

	//o[ebNXobt@̏o͏ݒ
    output.pos    = posP;
    output.uv     = uv_;
	output.viewZ  = posV.z;
	output.posW = posW;
	output.norW = norW;
	//output.color  = color;
    return output;
}
//------------------------------------------------------------------
////tHO
float4  Fog(float  viewZ_,  float4  color_)
{	
	//nearȉ0Ƃ
	float  d  =  max(viewZ_ - fog.near,  0);
	//near`fore̊ԂŔZx𒲐
	float  m  =  min(  d / (fog.fore - fog.near), 1);

	float4  rtv;
	if(fog.mode){
		rtv  =  fog.color  *  m  +  color_  *  (1 - m);
	}
	else{
		rtv  =  float4(color_.r, color_.g, color_.b, color_.a * (1 - m));
	}
	return  rtv;
}
//------------------------------------------------------------------
//
//sNZVF[_[
//
//_@@@UV̍\̒_ɑ΂鏈
//
float4 PS_PNT( sVS_PNT_Out  ip_ ) : SV_Target
{
	//CeBO
	float4  color = float4(0, 0, 0, 0);
	if (lights.enable){
		for (int i = 0; i < 4; i++){
			if (lights.light[i].enable){
				//gUˁEʔ
				color += Lighting(ip_.posW, ip_.norW, lights.light[i]);
			}
		}
		//˗ʂKp
		color += mate.ambient  *  lights.ambient;
		//x̓}eÃft[Y瓾
		color.a = mate.diffuse.a;
	}
	else{
		//Cg
		color += mate.diffuse;
	}
	//ȔʂKp
	color.xyz += mate.emissive.xyz;
	//IuWFNgJ[iFύXjKp
	color *= mate.objectColor;

	//eNX`sNZ擾
	color *= tex0.Sample( samLinear, ip_.uv);
	//tHO𔽉f
	if(fog.enable){
		color  =  Fog(ip_.viewZ,  color);
	}
	return  color;
}
//
//
//VF[_\1
//------------------------------------------------------------------
//o[ebNXobt@[o͍\
struct sVS_PCT_Out
{	
    float4  pos			: SV_POSITION;
	float4	color		: COLOR;
	float2  uv			: TEXCOORD0;
	float	viewZ		: POSITION;
};
//------------------------------------------------------------------
//
//o[ebNXVF[_[
//
//_@J[@UV̍\̒_ɑ΂鏈
sVS_PCT_Out VS_PCT(		float3  pos_		: POSITION,
						float4  col_		: COLOR,
						float2  uv_			: TEXCOORD)
{
	sVS_PCT_Out output = (sVS_PCT_Out)0;
	output.pos = mul( float4(pos_.xyz,1), mat.w_v_p );
	output.color = mate.objectColor * col_;
	output.uv  = uv_;
	output.viewZ  = 0;
	return output;
}


//------------------------------------------------------------------
//
//sNZVF[_[
//
//_@F@UV̍\̒_ɑ΂鏈
//
float4 PS_PCT( sVS_PCT_Out  ip_ ) : SV_Target
{
	float4  col = ip_.color;
	col *= tex0.Sample( samLinear, ip_.uv);
	return  col;
}
//

//
//VF[_\2
//C`p
//o[ebNXobt@[o͍\
struct sVS_Ray_Out
{
	float4  pos			: SV_POSITION;
};
//------------------------------------------------------------------
//
//o[ebNXVF[_[
//
//_Wō\ꂽ_ɑ΂鏈
//
sVS_Ray_Out VS_Ray(float3  pos_		: POSITION)
{
	sVS_Ray_Out output = (sVS_Ray_Out)0;
	float4  posW = mul(float4(pos_.xyz, 1), mat.world);
	float4  posV = mul(posW, mat.view);
	float4  posP = mul(posV, mat.projection);

	output.pos = posP;
	return output;
}
//------------------------------------------------------------------
//
//sNZVF[_[
//
//_Wō\ꂽ|S̃sNZɑ΂鏈
//
float4 PS_Ray(sVS_Ray_Out  ip_) : SV_Target
{
	return  mate.objectColor;
}

//
//
//eNjbN(VF[_͂ɏȂƓȂ)
//
technique10 MyStdShaderTec
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS_PNT() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS_PNT() ) );
    }
    pass P1
    {
        SetVertexShader( CompileShader( vs_4_0, VS_PCT() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS_PCT() ) );
    }
	pass P2
	{
		SetVertexShader(CompileShader(vs_4_0, VS_Ray()));
		SetGeometryShader(NULL);
		SetPixelShader(CompileShader(ps_4_0, PS_Ray()));
	}
}

